<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PWM.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">PWM.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PWM.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 9, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_PWM_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_PWM_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;driver/ledc.h&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="classPWM.html">   21</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPWM.html">PWM</a> {</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <a class="code" href="classPWM.html#aa26673999e30f8cd236b3cc3b1f890bd">PWM</a>(</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keywordtype">int</span> gpioNum,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        uint32_t frequency       = 100,</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        ledc_timer_bit_t bitSize = LEDC_TIMER_10_BIT,</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        ledc_timer_t timer       = LEDC_TIMER_0,</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        ledc_channel_t channel   = LEDC_CHANNEL_0);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    uint32_t <a class="code" href="classPWM.html#a7d6403597b936f73be3a53b330d15f52">getDuty</a>();</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    uint32_t <a class="code" href="classPWM.html#a70e2e1ad7736f241eef020ec4c7e7fff">getFrequency</a>();</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classPWM.html#adae9be9a8c34c42d0f81dd0b4a24c14f">setDuty</a>(uint32_t duty);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classPWM.html#ab2a9dd4cbe6349d420eef610e8909011">setDutyPercentage</a>(uint8_t percent);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classPWM.html#a51543c5bf29d9f3ae83c7f5af176895d">setFrequency</a>(uint32_t freq);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classPWM.html#a839027de87bbee57a3dabe21d254d892">stop</a>(<span class="keywordtype">bool</span> idleLevel = <span class="keyword">false</span>);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    ledc_channel_t   m_channel;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    ledc_timer_t     m_timer;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    ledc_timer_bit_t m_dutyResolution; <span class="comment">// Bit size of timer.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;};</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_PWM_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classPWM_html_a51543c5bf29d9f3ae83c7f5af176895d"><div class="ttname"><a href="classPWM.html#a51543c5bf29d9f3ae83c7f5af176895d">PWM::setFrequency</a></div><div class="ttdeci">void setFrequency(uint32_t freq)</div><div class="ttdoc">Set the frequency/period in Hz.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:136</div></div>
<div class="ttc" id="classPWM_html"><div class="ttname"><a href="classPWM.html">PWM</a></div><div class="ttdoc">A wrapper for ESP32 PWM control.</div><div class="ttdef"><b>Definition:</b> PWM.h:21</div></div>
<div class="ttc" id="classPWM_html_aa26673999e30f8cd236b3cc3b1f890bd"><div class="ttname"><a href="classPWM.html#aa26673999e30f8cd236b3cc3b1f890bd">PWM::PWM</a></div><div class="ttdeci">PWM(int gpioNum, uint32_t frequency=100, ledc_timer_bit_t bitSize=LEDC_TIMER_10_BIT, ledc_timer_t timer=LEDC_TIMER_0, ledc_channel_t channel=LEDC_CHANNEL_0)</div><div class="ttdoc">Construct an instance.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:34</div></div>
<div class="ttc" id="classPWM_html_a7d6403597b936f73be3a53b330d15f52"><div class="ttname"><a href="classPWM.html#a7d6403597b936f73be3a53b330d15f52">PWM::getDuty</a></div><div class="ttdeci">uint32_t getDuty()</div><div class="ttdoc">Get the duty cycle value.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:62</div></div>
<div class="ttc" id="classPWM_html_a70e2e1ad7736f241eef020ec4c7e7fff"><div class="ttname"><a href="classPWM.html#a70e2e1ad7736f241eef020ec4c7e7fff">PWM::getFrequency</a></div><div class="ttdeci">uint32_t getFrequency()</div><div class="ttdoc">Get the frequency/period in Hz.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:72</div></div>
<div class="ttc" id="classPWM_html_ab2a9dd4cbe6349d420eef610e8909011"><div class="ttname"><a href="classPWM.html#ab2a9dd4cbe6349d420eef610e8909011">PWM::setDutyPercentage</a></div><div class="ttdeci">void setDutyPercentage(uint8_t percent)</div><div class="ttdoc">Set the duty cycle as a percentage value.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:98</div></div>
<div class="ttc" id="classPWM_html_a839027de87bbee57a3dabe21d254d892"><div class="ttname"><a href="classPWM.html#a839027de87bbee57a3dabe21d254d892">PWM::stop</a></div><div class="ttdeci">void stop(bool idleLevel=false)</div><div class="ttdoc">Stop the PWM.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:147</div></div>
<div class="ttc" id="classPWM_html_adae9be9a8c34c42d0f81dd0b4a24c14f"><div class="ttname"><a href="classPWM.html#adae9be9a8c34c42d0f81dd0b4a24c14f">PWM::setDuty</a></div><div class="ttdeci">void setDuty(uint32_t duty)</div><div class="ttdoc">Set the duty cycle value.</div><div class="ttdef"><b>Definition:</b> PWM.cpp:86</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
